// Regression test: using 32-bit floating point values was causing some points
// written to be stored at different coordinates due to floating point drift.

return

var test = require('tape')
var hyperlog = require('hyperlog')
var fdstore = require('fd-chunk-store')
var path = require('path')
var memdb = require('memdb')
var collect = require('collect-stream')

var tmpdir = require('os').tmpdir()

var dir = path.join(tmpdir, 'osm-fun-times')
var storefile = path.join(dir, 'kdb')

var osmdb = require('../')

test('store a point that float32 would be insufficient to store', function (t) {
  // t.plan(3)

  var level = require('level')
  var osm = osmdb({
    log: hyperlog(level(path.join(dir, 'log')), { valueEncoding: 'json' }),
    db: level(path.join(dir, 'index')),
    store: fdstore(4096, storefile)
  })
  // var osm = osmdb({
  //   log: hyperlog(memdb(), { valueEncoding: 'json' }),
  //   db: memdb(),
  //   store: fdstore(4096, storefile)
  // })

  var id
  // osm.create({ type: 'node', lat: -0.5788595375878169, lon: -75.26922116337403 }, function (err, docId) {
  //   t.error(err)
  //   id = docId
  //   console.log('ID 1', docId)
  //   osm.kdb.query([[-100,100],[-100,100]], function (err, pts) {
  //     console.log('pts 1', pts)
  //   })

    // osm.del(id, function (err) {
    //   t.error(err)
      var q0 = [[-100,100],[-100,100]]
      var ex0 = []
      osm.ready(function () {
        osm.kdb.query([[-100,100],[-100,100]], function (err, pts) {
          console.log('pts 2', pts)
        })
        osm.query(q0, function (err, res) {
          t.ifError(err)
          console.log(res)
          t.deepEqual(res.sort(idcmp), ex0, 'full coverage query')
          t.end()
        })
      })
    // })
  // })
})

function idcmp (a, b) {
  return a.id < b.id ? -1 : 1
}
